﻿//importamos la clase Point
import flash.geom.Point;
//definición de clase
class Trig {
	//constante estática para hallar radianes en 1º
	private static var g_r:Number = Math.PI/180;
	//la hacemos accesible
	public static function get degR():Number {
		return g_r;
	}
	//Esta función nos devolverá un punto dependiendo de la rotación
	public static function hallarPunto(angle:Number, distance:Number, initPos:Point):Point {
		//gestión de parámetros opcionales
		if (distance == undefined) {
			distance = 1;
		}
		if (initPos == undefined) {
			var initX = 0;
			var initY = 0;
		} else {
			var initX = initPos.x;
			var initY = initPos.y;
		}
		var xPos:Number = initX+distance*Math.sin(angle*g_r);
		//Hallamos la coordenada x del punto
		var yPos:Number = initY-distance*Math.cos(angle*g_r);
		//Lo mismo con la y, teniendo en cuenta que está invertida.
		var targetPoint:Point = new Point(xPos, yPos);
		//Concatenamos la informacióm en un punto
		return targetPoint;
		//lo devolvemos
	}
	//Esta función devuelve una rotación a partir de un punto de origen y otro dados.
	public static function hallarAngulo(targetPos:Point, cords:Point, rads:Boolean):Number {
		//extraemos coordenadas de los puntos
		if (cords == undefined) {
			var cr_x:Number = 0;
			var cr_y:Number = 0;
		} else {
			var cr_x:Number = cords.x;
			var cr_y:Number = cords.y;
		}
		var initX = targetPos.x;
		var initY = targetPos.y;
		//las restamos
		var xRef:Number = cr_x-initX;
		var yRef:Number = cr_y-initY;
		//Obtenemos el ángulo y devolvemos el resulado.
		var angle:Number = -Math.atan2(xRef, yRef);
		//Si nos indican que el ángulo es en radianes no hacemos nada,
		//de lo contrario lo convertimos a grados.
		if (rads != true) {
			angle /= g_r;
		}
		return angle;
	}
	//Estas funciones devolverán una de las coordenadas sabiendo la otra y un ángulo, así 
	//como las coordenadas iniciales.
	public static function hallarX(angle:Number, yPoint:Number, initCords:Point, rads:Boolean):Number {
		//Convertimos el ángulo en radianes si no nos lo dan.
		var ang:Number = angle;
		if (rads != true) {
			ang *= g_r;
		}
		if (initCords == undefined) {
			var initCords:Point = new Point(0, 0);
		}
		//calculamos lo que nos hemos desplazado en y.               
		var yDif:Number = initCords.y-yPoint;
		//Si yDif=radio*Math.cos(ang):
		var radio:Number = yDif/Math.cos(ang);
		//Si el radio resulta ser menor que cero, la ecuación no tiene sentido y no se cruzan.
		if (radio<0) {
			return null;
		}
		//Hallado el radio ya solo falta hallar la x.    
		var xPos:Number = radio*Math.sin(ang)+initCords.x;
		return xPos;
	}
	public static function hallarY(angle:Number, xPoint:Number, initCords:Point, rads:Boolean):Number {
		var ang:Number = angle;
		if (rads != true) {
			ang *= g_r;
		}
		if (initCords == undefined) {
			var initCords:Point = new Point(0, 0);
		}
		var xDif:Number = initCords.x-xPoint;
		var radio:Number = xDif/Math.sin(ang);
		//Aquí es al revés. Siempre Que hay colisión, el radio es negativo.
		if (radio>0) {
			return null;
		}
		var yPos:Number = radio*Math.cos(ang)+initCords.y;
		return yPos;
	}
	//
	//
	//
	//
}
